//==============================================================
// 萔
float4x4 World;
float4x4 WView;
float4x4 WVProj;
float4 Diffuse;
float4 Ambient;
float3 Light;
texture MeshTex;
texture ToonTex;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler ToonSmp=sampler_state {
	Texture=<ToonTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
};

//==============================================================
// VF[_iyCgj

// _VF[_
void ToonPaintVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float2 MeshUV : TEXCOORD0,
	out float2 ToonUV : TEXCOORD1
) {
	// _WAeNX`W
	Pos=mul(pos, WVProj);
	MeshUV=mesh_uv;
	
	// gD[eNX`W
	float3 w_normal=normalize(mul(normal, (float3x3)World));
	ToonUV.x=max(0, dot(w_normal, -Light))+Ambient;
	ToonUV.y=0.5;
}

// sNZVF[_
float4 ToonPaintPS(
	float2 MeshUV : TEXCOORD0,
	float2 ToonUV : TEXCOORD1
) : COLOR {
	return
		tex2D(MeshSmp, MeshUV)*
		tex2D(ToonSmp, ToonUV)*Diffuse;
}

//==============================================================
// eNjbN
technique ToonPaintInk {
	pass P0 {
		CullMode=CCW;
		VertexShader=compile vs_1_1 ToonPaintVS();
		PixelShader=compile ps_1_1 ToonPaintPS();
	}
}
